﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Data.Odbc;
using System.Data.Sql;
using System.Data.SqlClient;



namespace Esimerkki_12_9
{
    public partial class Paaikkuna : Form
    {


        //Tässä esitellään yhteysTeksti-muuttuja, joka tulee
        //sisältämään tietokantayhteyden tärkeät tiedot.
        string yhteysTeksti;

        //Tässä esitellään oleDbYhteys-olio, jolla yhteys
        //tietokantaan muodostetaan. 
        OleDbConnection oleDbYhteys;

        //Tässä esitellään kauppaTietojoukko-olio, joka tulee
        //sisältämään haetut taulukkotiedot.
        DataSet kauppaTietojoukko;

        public Paaikkuna()
        {
            InitializeComponent();
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {

            //Tässä määritellään yhteysTeksti, joka sisältää mm. tiedot tietokannan tyypistä, sijainnista. 
            yhteysTeksti = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Esimerkit\Esimerkit_luku12\Kauppa.mdb;Persist Security Info=False";


          
            //Tässä muodostetaan yhtesy tietokantaan. 
            oleDbYhteys = new OleDbConnection(yhteysTeksti);

            //Tässä kauppaTietojoukko-olio alustetaan.
            kauppaTietojoukko = new DataSet();

        }

        private void lisäysPainike_Click(object sender, EventArgs e)
        {

            //Seuraavassa tarkistetaan onko mikään tekstikenttä tyhjä. Jos jokin
            //tekstikentistä on tyhjä, käyttäjälle ilmoitetaan asiasta, pyydetään
            //antamaan kaikki tiedot ja poistutaan metodista.
            if (string.IsNullOrEmpty(lIDTekstikenttä.Text) || string.IsNullOrEmpty(lNimiTekstikenttä.Text) ||
                string.IsNullOrEmpty(lYHTekstikenttä.Text))
            {

                MessageBox.Show("Anna kaikki tiedot!", "Virhe");
                return;

            }


            //Tässä luodaan hakuKomento-olio.
            OleDbCommand hakuKomento = oleDbYhteys.CreateCommand();

            //Tässä hakuKomento-olion komentoteksti alustetaan SQL-komennolla, joka
            //hakee tuotteen ID:n käyttäjän antaman ID:n perusteella. Näin voidaan tarkistaa
            //onko käyttäjän antama tuotteen ID jo taulukossa.  
            hakuKomento.CommandText = "select ID from Tuotteet where ID like + '" + lIDTekstikenttä.Text + "'";

            //Tässä luodaan oleDbDataAdapteri-olio.  
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();

            //Tässä alustetaan taulukkoAdapteri:n SelectCommand.
            taulukkoAdapteri.SelectCommand = hakuKomento;

            //Tässä avataan tietokantayhteys jos se on suljettu.
            if(oleDbYhteys.State==ConnectionState.Closed)
              oleDbYhteys.Open();


            //Tässä kutsutaan ExecuteScalar()-metodi, joka palauttaa 
            //skalaarikyselyn tuloksen, joka on yksittäinen arvo. Tämä arvo
            //on tyyppiä object.
            object tarkistusKyselynTulos = taulukkoAdapteri.SelectCommand.ExecuteScalar();


            //Jos skalaarikyselyn tulos ei ole null, päätellään että käyttäjän
            //syöttämä tuotteen ID on jo olemassa taulukossa ja ilmoitetaan asiasta
            //käyttäjälle, suljetaan tietokantayhteys ja poistutaan metodista.
            if (tarkistusKyselynTulos != null)
            {
                //Tässä ilmoitetaan, että ID on jo olemassa taulukossa.
                MessageBox.Show(lIDTekstikenttä.Text + " on jo olemassa! ", "Virhe");
                
                //Täss suljetaan tietokantayhteys.
                oleDbYhteys.Close();
                
                //Tässä poistutaan metodista.
                return;
            }


            //Tässä luodaan  OleDbCommand-olio, joka sisältää SQL-komennon. 
            OleDbCommand lisäysKomento = oleDbYhteys.CreateCommand();

            //Tässä kirjoitetaan SQL-komento ja lisätään lisäysKomento-olioon. 
            //Huomaa, että SQL-komennon values() sisältää kolmea parametria, joiden
            //tietotyypit ja arvot määritellään myöhemmin.
            lisäysKomento.CommandText = "insert into Tuotteet (ID, Nimi, Yksikköhinta) values(@id, @nimi, @yksikköhinta)";

            //Tässä lisäysKomento-olioon lisätään paramteri, jonka nimi on id,
            //tietotyyppi on VarChar, koko on 5 ja joka viittaa ID-sarakkeeseen.
            lisäysKomento.Parameters.Add("@id", OleDbType.VarChar, 4, "ID");

            //Tässä lisäysKomento-olioon lisätään paramteri, jonka nimi on nimi,
            //tietotyyppi on VarChar, koko on 15 ja joka viittaa Nimi-sarakkeeseen.
            lisäysKomento.Parameters.Add("@nimi", OleDbType.VarChar, 15, "Nimi");

            //Tässä lisäysKomento-olioon lisätään paramteri, jonka nimi on yksikköhinta,
            //tietotyyppi on Double, koko on 7 ja joka viittaa Yksikköhinta-sarakkeeseen.
            lisäysKomento.Parameters.Add("@Yksikköhinta", OleDbType.Double, 7, "Yksikköhinta");

            //Tässä oleDbDataAdapterin lisäyskomennoksi (InsertCommand) laitetaan
            //lisäysKomento, joka aiemmin määriteltiin.
            taulukkoAdapteri.InsertCommand = lisäysKomento;


            //Tässä tarkistetaan onko Tuotteet-taulukko jo lisätty 
            //tietojoukkoon. Jos ei, kutsutaan näytäPainike_Click()-metodi
            //lisäämään Tuotteet-taulukko tietojoukkoon.
            if (kauppaTietojoukko.Tables.Count == 0)
                näytäPainike_Click(sender, e);


            //Tässä luodaan DataRow-olio, jolla on sama rakenne, kuin
            //Tuotteet-taulukon rivillä. 
            DataRow uusiTietoRivi = kauppaTietojoukko.Tables["Tuotteet"].NewRow();

            //Seuraavassa alustetaan uusiTietoRivin sarakkeet sopivien
            //tekstikenttien sisällöillä.
            uusiTietoRivi["ID"] = lIDTekstikenttä.Text;
            uusiTietoRivi["Nimi"] = lNimiTekstikenttä.Text;
            uusiTietoRivi["Yksikköhinta"] = lYHTekstikenttä.Text;

            //uusiTietoRivi["Yksikköhinta"] = 1.88;

            //Tässä kauppaTietojoukko:n Tuotteet-taulukkoon
            //lisätään uusiTietoRivi.
            kauppaTietojoukko.Tables["Tuotteet"].Rows.Add(uusiTietoRivi);

            //Tässä kutsutaan taulukkoAdapteri:n Update()-metodi, joka kirjoittaa
            //tietojoukon päivitetyn sisällön alkuperäiseen tietokantaan ja palauttaa
            //päivitettyjen rivien lukumäärän.
            int päivitettyRivi = taulukkoAdapteri.Update(kauppaTietojoukko.Tables["Tuotteet"]);

            //Tässä käyttäjälle ilmoitetaan taulukon päivityksen tulos.
            MessageBox.Show(this, päivitettyRivi + " rivi lisättiin.", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }



        private void lopetusPainike_Click(object sender, EventArgs e)
        {
            //Tässä ohjelma lopetetaan.
            Application.Exit();
        }




        private void näytäPainike_Click(object sender, EventArgs e)
        {

            //Tässä taulukkonäkymä putsataan asettamalla sen tietolähteeksi null.
            taulukkoNäkymä.DataSource = null;

            //Tässä luodaan komento-olio.
            OleDbCommand hakuKomento = oleDbYhteys.CreateCommand();

            //Tässä määritellään komento-olion SQL-komento.
            hakuKomento.CommandText = "SELECT ID, Nimi, Yksikköhinta FROM Tuotteet";

            //Tässä luodaan taulukkoAdapteri-olio.
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();

            //Tässä määrietllään taulukkoAdapteri-olion SelectCommand-ominaisuus.
            taulukkoAdapteri.SelectCommand = hakuKomento;


            //Tässä kutsutaan taulukkoAdapteri:n Fill()-metodi, joka
            //luo Tuotteet-taulukon tietojoukkoon.
            taulukkoAdapteri.Fill(kauppaTietojoukko, "Tuotteet");

            //Tässä taulukkonäkymän tietolähteeksi laitetaan kauppaTietojoukko:n
            //Tuotteet-taulukko siten, että kaikki sarakkeet
            //näytetään (DefaultView).
            taulukkoNäkymä.DataSource = kauppaTietojoukko.Tables["Tuotteet"].DefaultView;
          //  taulukkoNäkymä.DataSource = kauppaTietojoukko.Tables[0].DefaultView;

        }

        private void putsaaPainike_Click(object sender, EventArgs e)
        {
            //Tässä taulukkoNäkymä:n tiedot saadaan häviämään
            //asettamalla sen tietolähteeksi null.
            taulukkoNäkymä.DataSource = null;
        }

        private void mHakuPainike_Click(object sender, EventArgs e)
        {
            //Tässä luodaan komento-olio.
            OleDbCommand haeTuoteKomento = oleDbYhteys.CreateCommand();

            //Tässä määritellään komento-olion SQL-komento.
            haeTuoteKomento.CommandText = "SELECT Nimi, Yksikköhinta FROM Tuotteet where ID like '" + mIDTekstikenttä.Text + "'";

            //Tässä luodaan taulukkoAdapteri-olio.
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();

            //Tässä määrietllään taulukkoAdapteri-olion SelectCommand-ominaisuus.
            taulukkoAdapteri.SelectCommand = haeTuoteKomento;

            //Tässä avataan tietokantayhteys jos se on suljettu.
            if (oleDbYhteys.State == ConnectionState.Closed)
                oleDbYhteys.Open();


            //Tässä kutsutaan SelectCommand-olion ExecuteReader()-metodi, joka
            //palauttaa kyselyn tuloksen OleDbDataReader-oliona.
            OleDbDataReader lukija = taulukkoAdapteri.SelectCommand.ExecuteReader();

            //Seuraavassa tarkistetaan onko kyselyn tulos ilman rivejä. 
            //Jos on niin, nimi- ja yksikköhinta-tekstikentät tyhjennetään
            //ja käyttäjälle ilmoitetaan, ettei annettua ID:tä löydy ja
            //poistutaan metodista.
            if (!lukija.HasRows)
            {
                mNimiTekstikenttä.Text = "";
                mYHTekstikenttä.Text = "";

                MessageBox.Show(mIDTekstikenttä.Text + " ei löydy!", "Virhe");


                return;
            }


            //Seuraavassa käydään lukija-olion sisältö läpi ja sen
            //sarakkeiden arvoilla alustetaan nimi- ja yksikköhintatekstikenttä. 
            while (lukija.Read())
            {
                mNimiTekstikenttä.Text = lukija[0].ToString();
                mYHTekstikenttä.Text = lukija[1].ToString();
            }


            //Tässä tietokantayhteys suljetaan.
            oleDbYhteys.Close();
        }

        private void tallennusPainike_Click(object sender, EventArgs e)
        {

            //Tässä luodaan komento-olio.
            OleDbCommand muokkausKomento = oleDbYhteys.CreateCommand();

            //Tässä määritellään komento-olion SQL-komento.
            muokkausKomento.CommandText = "UPDATE Tuotteet SET Nimi=@nimi, Yksikköhinta=@yksikköhinta where ID like '" + mIDTekstikenttä.Text + "'";


            //Tässä muokkausKomento-olioon lisätään paramteri, jonka nimi on nimi,
            //tietotyyppi on VarChar, koko on 15 ja joka viittaa Nimi-sarakkeeseen.
            muokkausKomento.Parameters.Add("@nimi", OleDbType.VarChar, 15, "Nimi");

            //Tässä muokkausKomento-olioon lisätään paramteri, jonka nimi on yksikköhinta,
            //tietotyyppi on Double, koko on 7 ja joka viittaa Yksikköhinta-sarakkeeseen.
            muokkausKomento.Parameters.Add("@Yksikköhinta", OleDbType.Double, 7, "Yksikköhinta");

            //Tässä luodaan tuoteTiedot-taulukko, joka alustetaan tekstikenttien arvoilla. 
            object[] tuoteTiedot = new object[] { mIDTekstikenttä.Text, mNimiTekstikenttä.Text, double.Parse(mYHTekstikenttä.Text) };


            //Tässä tarkistetaan onko Tuotteet-taulukko jo lisätty 
            //tietojoukkoon. Jos ei, kutsutaan näytäPainike_Click()-metodi
            //lisäämään Tuotteet-taulukko tietojoukkoon.
            if (kauppaTietojoukko.Tables.Count == 0)
                näytäPainike_Click(sender, e);


            //Tässä LoadDataRow()-metodin avulla ensin etsitään tai luodaan 
            //kauppaTietojoukko:n Tuotteet-taulukosta rivi, jolla on samat tiedot
            //kuin tuoteTiedot.
            DataRow tuoteRivi = kauppaTietojoukko.Tables["Tuotteet"].LoadDataRow(tuoteTiedot, true);


            //Seuraavassa tuoteRivi:n sarakkeet päivitetään sopivien
            //tekstikenttien sisällöillä.
            tuoteRivi["Nimi"] = mNimiTekstikenttä.Text;
            tuoteRivi["Yksikköhinta"] = mYHTekstikenttä.Text;

            //Tässä luodaan taulukkoAdapteri-olio.
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();

            //Tässä määrietllään taulukkoAdapteri-olion UpdateCommand-ominaisuus.
            taulukkoAdapteri.UpdateCommand = muokkausKomento;

            //Tässä kutsutaan taulukkoAdapteri:n Update()-metodi, joka kirjoittaa
            //tietojoukon päivitetyn sisällön alkuperäiseen tietokantaan ja palauttaa
            //päivitettyjen rivien lukumäärän.
            int päivitettyRivi = taulukkoAdapteri.Update(kauppaTietojoukko, "Tuotteet");


            //Tässä ilmoitusikkunalla ilmoitetaan kuinka monta riviä päivitettiin.
            MessageBox.Show(this, päivitettyRivi + " rivi päivitetttiin.", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);


        }


        private void HaeTiedo(TextBox idTekstikenttä, TextBox nimiTekstikenttä, TextBox yhTekstikenttä)
        {


        }



        private void pHakuPainike_Click(object sender, EventArgs e)
        {
           

            //Tässä luodaan komento-olio.
            OleDbCommand haeTuoteKomento = oleDbYhteys.CreateCommand();

            //Tässä määritellään komento-olion SQL-komento.
            haeTuoteKomento.CommandText = "SELECT Nimi, Yksikköhinta FROM Tuotteet where ID like '" + pIDTekstikenttä.Text + "'";

            //Tässä luodaan taulukkoAdapteri-olio.
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();

            //Tässä määrietllään taulukkoAdapteri-olion SelectCommand-ominaisuus.
            taulukkoAdapteri.SelectCommand = haeTuoteKomento;


            //Seuraavassa tietokantayhteys avataan jos se on jo suljettu.
            if(oleDbYhteys.State==ConnectionState.Closed)            
             oleDbYhteys.Open();

            //Tässä kutsutaan SelectCommand-olion ExecuteReader()-metodi, joka
            //palauttaa kyselyn tuloksen OleDbDataReader-oliona.
            OleDbDataReader lukija = taulukkoAdapteri.SelectCommand.ExecuteReader();

            //Seuraavassa tarkistetaan onko kyselyn tulos ilman rivejä. 
            //Jos on niin, nimi- ja yksikköhinta-tekstikentät tyhjennetään
            //ja käyttäjälle ilmoitetaan, ettei annettua ID:tä löydy ja
            //poistutaan metodista.
            if (!lukija.HasRows)
            {
                pNimiTekstikenttä.Text = "";
                pYHTekstikenttä.Text = "";

                MessageBox.Show(pIDTekstikenttä.Text + " ei löydy!", "Virhe");


                return;
            }


            //Seuraavassa käydään lukija-olion sisältö läpi ja sen
            //sarakkeiden arvoilla alustetaan nimi- ja yksikköhintatekstikenttä. 
            while (lukija.Read())
            {
                pNimiTekstikenttä.Text = lukija[0].ToString();
                pYHTekstikenttä.Text = lukija[1].ToString();
            }


            //Tässä tietokantayhteys suljetaan.
            oleDbYhteys.Close();

        }

        private void poistoPainike_Click(object sender, EventArgs e)
        {

            //Seuraavassa tarkistetaan onko mikään tekstikenttä tyhjä. Jos jokin
            //tekstikentistä on tyhjä, käyttäjälle ilmoitetaan asiasta, pyydetään
            //antamaan kaikki tiedot ja poistutaan metodista.
            if (string.IsNullOrEmpty(pIDTekstikenttä.Text) || string.IsNullOrEmpty(pNimiTekstikenttä.Text) ||
                string.IsNullOrEmpty(pYHTekstikenttä.Text))
            {

                MessageBox.Show("Anna kaikki tiedot!", "Virhe");
                return;

            }
    
          

            //Tässä luodaan komento-olio.
            OleDbCommand poistoKomento = oleDbYhteys.CreateCommand();

            //Tässä määritellään komento-olion SQL-komento.
            poistoKomento.CommandText = "DELETE FROM Tuotteet where ID like '" + pIDTekstikenttä.Text + "'";

            //Tässä kutsutaan taulukkoAdapteri:n Update()-metodi, joka kirjoittaa
            //tietojoukon päivitetyn sisällön alkuperäiseen tietokantaan ja palauttaa
            //päivitettyjen rivien lukumäärän.


            //Seuraavassa tietokantayhteys avataan jos se on suljettu.
            if (oleDbYhteys.State == ConnectionState.Closed)
                oleDbYhteys.Open();


            //Tässä luodaan tuoteTiedot-taulukko, joka alustetaan tekstikenttien arvoilla. 
            object[] tuoteTiedot = new object[] { pIDTekstikenttä.Text, pNimiTekstikenttä.Text, pYHTekstikenttä.Text };


            //Tässä tarkistetaan onko Tuotteet-taulukko jo lisätty 
            //tietojoukkoon. Jos ei, kutsutaan näytäPainike_Click()-metodi
            //lisäämään Tuotteet-taulukko tietojoukkoon.
            if (kauppaTietojoukko.Tables.Count == 0)
                näytäPainike_Click(sender, e);


            //Tässä LoadDataRow()-metodin avulla etsitään tai luodaan 
            //kauppaTietojoukko:n Tuotteet-taulukosta rivi, jolla on 
            //tuoteTiedot-taulukossa merkityt tiedot.
             DataRow tuoteRivi = kauppaTietojoukko.Tables["Tuotteet"].LoadDataRow(tuoteTiedot, true);

            //Tässä rivi merkitään poistettavaksi.
            tuoteRivi.Delete();

            //Tässä luodaan taulukkoAdapteri-olio.
            OleDbDataAdapter taulukkoAdapteri = new OleDbDataAdapter();


            //Tässä määrietllään taulukkoAdapteri-olion DeleteCommand-ominaisuus.
            taulukkoAdapteri.DeleteCommand = poistoKomento;


            //Tässä kutsutaan taulukkoAdapteri:n Update()-metodi, joka kirjoittaa
            //tietojoukon päivitetyn sisällön alkuperäiseen tietokantaan ja palauttaa
            //päivitettyjen rivien lukumäärän.
            int poistoRivi = taulukkoAdapteri.Update(kauppaTietojoukko.Tables["Tuotteet"]);

            //Tässä rivin poisto tietokannasta hyväksytään lopullisesti.
            taulukkoAdapteri.AcceptChangesDuringUpdate = true;

            //Tässä ilmoitusikkunalla ilmoitetaan kuinka monta riviä päivitettiin.
            MessageBox.Show(this, poistoRivi + " rivi poistettiin.", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);

            //Tässä tietokantayhteys suljetaan.
            oleDbYhteys.Close();

        }
    }
}

