﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Esimerkki12_7
{
    public partial class Paaikkuna : Form
    {

        //Seuraavassa määritellään joukko globaalimuuttujia, joita
        //alustetaan myöhemmin.
        Series series;
        string valittuFunktio;
        int indeksi;
        int alkuArvo;
        int loppuArvo;


        public Paaikkuna()
        {
            InitializeComponent();
        }


        private void piirräPainike_Click(object sender, EventArgs e)
        {
          

            //Seuraavassa tarkistetaan ovatk alku- ja loppuarvotekstikentät tyhjiä ja jos ne ovat,
            //metodin suoritus keskeytetään.
            if (string.IsNullOrEmpty(alkuarvoTekstikenttä.Text) || string.IsNullOrEmpty(loppuarvoTekstikenttä.Text))
                return;

            //Tässä valittuFunktio-muuttuja alustetaan pudotusvalikosta valitun alkion nimellä.
             valittuFunktio=funktioPudotusvalikko.SelectedItem.ToString();


             //Seuraavassa tarkistetaan kuuluuko valittu funktio
             //jo diagrammiin. Jos se kuuluu, se ensin poistetaan
             //ennen sen uudelleen piirtämistä.
             indeksi = diagrammi.Series.IndexOf(valittuFunktio);
             if (indeksi != -1)
                 diagrammi.Series.RemoveAt(indeksi);


             //Seuraavassa valittufunktio lisätään diagrammiin ja
             //samalla series-muuttuja alustetaan.
             series = this.diagrammi.Series.Add(valittuFunktio);

             //Tässä valitaan diagrammityyppi tietojoukolle.
             series.ChartType = SeriesChartType.Line;

             //Tässä asetetaan piirrustusviivan leveys. 
             series.BorderWidth = 5;

             //Seuraavassa selvitetään käyttäjän antamat alku- ja
             //loppuarvot.
             alkuArvo = Int16.Parse(alkuarvoTekstikenttä.Text);
             loppuArvo = Int16.Parse(loppuarvoTekstikenttä.Text);

             //Seuraavassa tarkistetaan onko alkuarvo suurempi kuin
             //loppuarvo. Jos on niin, asiasta ilmoitetaan ilmoitusikkunalla
            //ja poistutaan metodista.
             if (alkuArvo > loppuArvo)
             {
                 MessageBox.Show(alkuArvo + " > " + loppuArvo + "!", "Virhe");
                 return;
             }

               //Seuraavassa ensin diagrammin mahdolliset otsikot poistetaan ja sitten
            //siihen lisätään uusi otsikko, joka myös sisältää uudet alku- ja loppuarvot.
            diagrammi.Titles.Clear();
            diagrammi.Titles.Add("f(x), x=[" + alkuArvo + " , " + loppuArvo + "]");

            //Seuraavassa tarkistetaan kuuluuko valittu funktio diagrammin
            //Legends-kokoelmaan. Jos se ei kuulu, se lisätään diagrammin
            //Legend-kokoelmaan.
            indeksi = diagrammi.Legends.IndexOf(valittuFunktio);
            if(indeksi==-1)
               diagrammi.Legends.Add(valittuFunktio);
           
            

            //Seuraavassa selvitetään pudotusvalikosta valitun alkion indeksi ja
            //sen perusteella piirretään sopiva funktion. 
            switch(funktioPudotusvalikko.SelectedIndex) {

                case 0:
                    //Seuraavassa piirrettävät pisteet (x, sin(x)) lisätään
                    //tietojoukkoon ja ne piirretään diagrammilla.
                     for (int i = alkuArvo; i <= loppuArvo; i++)
                         series.Points.AddXY(i, Math.Sin(Math.PI / 180 * i));
                break;


                case 1:

                //Seuraavassa piirrettävät pisteet (x, cos(x)) lisätään
                //tietojoukkoon ja ne piirretään diagrammilla.
                for ( int i = alkuArvo ; i <= loppuArvo; i++)
             
                    series.Points.AddXY(i, Math.Cos(Math.PI / 180 * i));

                break;

                case 2:

    

                //Seuraavassa piirrettävät pisteet (x, tang(x)) lisätään
                //tietojoukkoon ja ne piirretään diagrammilla.
           for ( int i = alkuArvo ; i <= loppuArvo; i++)
                series.Points.AddXY(i, 2*Math.Pow(Math.Sin(Math.PI/180*i),2)-3*Math.Cos(Math.PI/180*i)+1);
                    break;

            }

          

         

            
	}


        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            //Tässä pudotusvalikon ensimmäinen alkio asetetaan valituksi.
            funktioPudotusvalikko.SelectedIndex = 0;

            //Seuraavassa diagrammin akseleille määritellään otsikot.
            diagrammi.ChartAreas.ElementAt(0).AxisX.Title = "x";
            diagrammi.ChartAreas.ElementAt(0).AxisY.Title = "f(x)";

        }

        private void funktioPudotusvalikko_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void alustaPainike_Click(object sender, EventArgs e)
        {

            //Seuraavassa diagrammin tietojoukot ja otsikot poistetaan.
            diagrammi.Series.Clear();
            diagrammi.Titles.Clear();
        }

        }
    }

