﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki4_3
{
    public partial class Paaikkuna : Form
    {

        //Seuraavissa määritellään muuttujia Font- ja Random-
        //olioiden määrittelemiseksi.
        FontFamily alkuFf, uusiFf;
        Font alkuFontti, uusiFontti;
        Random r;

        public Paaikkuna()
        {
            InitializeComponent();


            //Seuraavissa määritellään valintaruutujen alkufontti.
             alkuFf = new FontFamily("Microsoft Sans Serif");
             alkuFontti = new Font(alkuFf, 8, GraphicsUnit.Point);

             //Seuraavissa määritellään valintaruutuille uusi fontti.
             uusiFf = new FontFamily("Times New Roman");
             uusiFontti = new Font(uusiFf, 14, GraphicsUnit.Point);

             //Tässä määritellään Random-olio satunnaislukujen 
            //generointia varten.
             r = new Random();
        }

     

        private void variValintaRuutu_CheckedChanged(object sender, EventArgs e)
        {
            
          //Seuraavassa ensin tarkistetaan onko valintaruutu valitussa tilassa. 
          //Jos se on valitussa tilassa, sen fonttia ja tämän väriä vaihdetaan 
          //sekä pääikkunan taustaväriä muutetaan satunnaisesti. Jos valintaruutu
          //ei ole valitussa tilassa, sen fontiksi ja tämän väriksi laitetaan 
          //alkutilan mukaan.
            if (variValintaRuutu.Checked)
            {
                variValintaRuutu.Font = uusiFontti;
                variValintaRuutu.ForeColor = Color.Yellow;
                this.BackColor = Color.FromArgb(r.Next(256), r.Next(256), r.Next(256));
            }
            else
            {
                 variValintaRuutu.Font = alkuFontti;
                 variValintaRuutu.ForeColor = Color.Black;
            }

        }

        private void kokoValintaRuutu_CheckedChanged(object sender, EventArgs e)
        {

            //Tässä luodaan Size-olio, joka sisältää ikkunan alkukoon.
            Size alkuKoko = new Size(363, 225);

            //Seuraavassa ensin tarkistetaan onko valintaruutu valitussa tilassa. 
            //Jos se on valitussa tilassa, sen fonttia ja tämän väriä vaihdetaan 
            //sekä pääikkunan kokoa muutetaan satunnaisesti. Jos valintaruutu
            //ei ole valitussa tilassa, sen fontiksi ja tämän väriksi laitetaan 
            //alkutilan mukaan. Lisäksi, ikkunan koko palautetaan alkutilaan.
            if (kokoValintaRuutu.Checked)
            {
                kokoValintaRuutu.Font = uusiFontti;
                kokoValintaRuutu.ForeColor = Color.Yellow;
                this.Size = new Size(alkuKoko.Width + r.Next(50), alkuKoko.Height + r.Next(50));
               
            }
            else
            {
                kokoValintaRuutu.Font = alkuFontti;
                kokoValintaRuutu.ForeColor = Color.Black;

                this.Size = alkuKoko;
            }
        }

        private void sijaintiValintaRuutu_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä luodaan Point-olio, joka sisältää ikkunan alkusijainnin.
            Point alkuSijainti = new Point(30, 132);

            //Seuraavassa ensin tarkistetaan onko valintaruutu valitussa tilassa. 
            //Jos se on valitussa tilassa, sen fonttia ja tämän väriä vaihdetaan 
            //sekä pääikkunan sijaintia muutetaan satunnaisesti. Jos valintaruutu
            //ei ole valitussa tilassa, sen fontiksi ja tämän väriksi laitetaan 
            //alkutilan mukaan. Lisäksi, ikkunan sijainti palautetaan alkutilaan.
            if (sijaintiValintaRuutu.Checked)
            {
                sijaintiValintaRuutu.Font = uusiFontti;

                sijaintiValintaRuutu.ForeColor = Color.Yellow;
                this.Location = new Point(alkuSijainti.X + r.Next(50), alkuSijainti.Y + r.Next(50));
            }
            else
            {
                sijaintiValintaRuutu.Font = alkuFontti;
                sijaintiValintaRuutu.ForeColor = Color.Black;

                this.Location = alkuSijainti;
            }
        }

     

    }
}
