﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace Esimerkki5_1
{
    public partial class Paaikkuna : Form
    {

        //Seuraavissa esitellään joukko globaalimuuttujia, joita
        //myöhemmin käytetään ohjelmassa.
        double yhteisHinta=0.0;
        ArrayList kirjat;
        int[] lukumaarat;
        double[] valiSummat;


        public Paaikkuna()
        {
            InitializeComponent();
        }


        private void AlustaKirjatKokoelma(){

            //Tässä kirjat-ArrayList alustetaan.
            kirjat = new ArrayList();

            //Seuraavissa luodaan uusia Kirjat-olioita lennossa ja lisätään
            //kirjat-kokoelmaan. 
            kirjat.Add(new Kirja("Kurjat", "Victor Hogo", 19.20));
            kirjat.Add(new Kirja("Anna Karenina", "Leo Tolstoi", 23.45));
            kirjat.Add(new Kirja("Nana", "Emile Zola", 10.60));
            kirjat.Add(new Kirja("Äiti", "Maxim Gorki", 18.80));
            kirjat.Add(new Kirja("Rikos ja Rangaistus", "Fjodor Dostojevski", 15.30));
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            //Tässä kutsutaan AlustaKirjatKokoelma(), joka alustaa
            //kirjat-listan.
            AlustaKirjatKokoelma();

            //Tässä alustetaan lukumaarat-taulukko, jonka koko on
            //sama kuin kirjat-kokoelman koko. Tämän taulukon avulla
            //seurataan kuinka monta kertaa kunkin kirjan nimeä
            //on napsautettu.
            lukumaarat=new int[kirjat.Count];

            //Tässä alustetaan valiSummat-taulukko, jonka koko on
            //sama kuin kirjat-kokoelman koko. Tämän taulukon avulla
            //seurataan ostoksen välisummaa, joka lasketaan joak kijan
            //kohdalla kertamalla kirjan hinta ja se, kuinka monta kertaa
            //kirjaa napsautettiin.
            valiSummat = new double[kirjat.Count];

            //Tässä kirjatListBox:n tietoläheeksi laitetaan 
            //kirjat-kokoelma. Tämän jälkeen kirjatListBox:ssa
            //näkyy kirjat-kokoelman sisältö. 
            kirjatListBox.DataSource = kirjat;

            //Tässä, listassa Kirja-olioita esittäväksi 
            //tekstiksi laitetaan KirjanNimi-ominaisuuden
            //palauttama arvo, eli kirjan nimi.
            kirjatListBox.DisplayMember = "KirjanNimi";

            //Tässä listassa Kirja-olioita vastaavaksi 
            //arvoksi laitetaan Hinta-ominaisuuden
            //palauttama arvo, eli kirjan hinta.
            kirjatListBox.ValueMember = "Hinta";

            //Tässä varmistetaan, ettei listasta 
            //mikään elementtiä on valittu alussa. 
            kirjatListBox.ClearSelected();
        }

        private void kirjatListBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            //Tässä varmistetaan onko kirjatListBox:sta valitun
            //elementin arvo tyyppiä double. Jos on, sitten  
            if (kirjatListBox.SelectedValue is double)
            {
                //Tässä valitun elementin lukumäärää kasvatetaan yhdellä.
                //HUomaa, että kirjatListBox.SelectedIndex viittaa valitun
                //elementin indeksiin listassa. Listassa elementtien indeksit
                //alkavat nollasta.
                lukumaarat[kirjatListBox.SelectedIndex]++;

                //Tässä määritellään uusi fontti, jolla ostokset näytetään
                //ostoksetRichTextBox-tekstialueella.
                Font tekstiFontti = new Font(new FontFamily("Microsoft sans serif"), 8, FontStyle.Bold);

                //Tässä ostoksetRichTextBox-tekstialueen fontiksi laitetaan
                //itse määrittelemä tekstiFontti.
                ostoksetRichTextBox.Font = tekstiFontti;

                //Tässä kirjoitetaan ostoksetRichTextBox-tekstialueeseen otsikko. 
                ostoksetRichTextBox.Text = "Hinta\tMäärä\tVälisumma" + Environment.NewLine;

                //Tässä varmistetaan että yhteisHinta on nollattu.
                yhteisHinta = 0.0;

                for (int i = 0; i < lukumaarat.Length; i++)
                {
                    //Koska valittujen kirjojen lukumäärät alussa on nolla.
                    //Tässä varmistetaan, että jos kirjaa ei ole vielä valittu
                    //lainkaan, sen tietoja ei näytetä ostoksetRichTextBox-tekstialueella.  
                    if (lukumaarat[i] != 0)
                    {
                        //Tässä jokaista valittua kirjaa varten kirjoitetaan kirjan hinta,
                        //lukumäärä ja siitä muodostuva välisumma.
                        ostoksetRichTextBox.Text += ((Kirja)kirjatListBox.Items[i]).Hinta + "\t" + lukumaarat[i] + "\t" + (((Kirja)kirjatListBox.Items[i]).Hinta * lukumaarat[i]) + Environment.NewLine;
                    }
                        //Tässä valitun kirjan välisumma lisätään ostosten yhteishintaan.
                        yhteisHinta += lukumaarat[i] * ((Kirja)kirjatListBox.Items[i]).Hinta;
                }


                //Tässä muuttujan yhteisHina arvi kirjoitetaan siihen varattuun lipukkeeseen.
                yhteisHintaLipuke.Text = "" + yhteisHinta;


            }
        }

    
    }
}
