﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki5_3
{
    public partial class Paaikkuna : Form
    {

        SanaKirja sanaKirja;

        public Paaikkuna()
        {
            InitializeComponent();
        }

     

        private void Paaikkuna_Load(object sender, EventArgs e)
        {

            //Seuravassa määritellään joukko sanoja ja niitä vastaavia
            //englanninkielisiä sanoja.
            string[] sanat = new string[] {"", "Aurinko", "Lämmin", "Päivä", "Meri", "Uida"};
            string[] merkitykset = new string[] {"",  "Sun", "Warm", "Day", "Sea", "Swim" };

            //Tässä sanaKirja-oli alustetaan kutsumalla SanaKirja-luokan muodostin,
            //joka vaatii kaksi string-taulukkoa.  
            sanaKirja = new SanaKirja(sanat, merkitykset);

            //Tässä sovelluksen sanatPudotusvalikko:n tietolähteeksi laitetaan
            //string-taulukko jonka sanaKirja-olion Sanat-ominaisuus palauttaa.
            sanatPudotusvalikko.DataSource = sanaKirja.Sanat;
        }

        private void sanatPudotusvalikko_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Tässä määritellään ComboBox-olio, joka viittaa pudotusvalikkoon,
            //joka on aiheuttanut tapahtuman.
            ComboBox sanaLuettelo = (ComboBox) sender;
            
            //Tässä englanninkieliseen vastineeseen varatun tekstikentän
            //Text-arvoksi laitetaan sana, jonka sanaKirja-olion Merkitys-
            //metodi palauttaa. Metodin Mekirtys() argumentiksi välitetään 
            //pudotusvalikon valittu arvo merkkijonona.
            sanaEnglanniksiTekstikentta.Text = sanaKirja.Merkitys(sanaLuettelo.SelectedValue.ToString());
        }

        private void lisaaSanapariPainike_Click(object sender, EventArgs e)
        {

            //Tässä varmistetaan, että tekstikentät sanaTekstikentta ja merkitysTekstikentta
            //eivät ole tyhijä.
            if (!(sanaTekstikentta.Text.Equals("") || merkitysTekstikentta.Text.Equals("")))
            {
                //Tässä tarkisteaan löytyykö sana ja sen merkitys sanakirjasta.
                //Jos ei löydy, se sitten lisätään sanakirjaan. 
                if  (sanaKirja.Merkitys(sanaTekstikentta.Text) == null)
                    sanaKirja.lisaaSanapari(sanaTekstikentta.Text, merkitysTekstikentta.Text);
                else
                {
                    //Seuraavassa tulostetaan keltaisella palauteteksti jos sana on jo
                    //sanakirjassa. 
                    infoPainike.ForeColor = Color.Yellow;
                    infoPainike.Text = sanaTekstikentta.Text + " on jo sanakirjassa!";
                }

            }

            //Tässä sanatPudotusvalikko:n tietolähteeksi laitetaan sanaKirja-olion
            //Sanat-ominaisuuden palauttama sanataulukko.
              sanatPudotusvalikko.DataSource = sanaKirja.Sanat;

              //Seuraavassa sanatPudotusvalikko:n valituksi elementiksi laitetaan 
            //juuri lisätty sana ja merkitys-tekstikenttään laitetaan sama sana englanniksi.
              sanatPudotusvalikko.SelectedText = sanaTekstikentta.Text;
              sanaEnglanniksiTekstikentta.Text = sanaKirja.Merkitys(sanaTekstikentta.Text);

        }

       
        private void sanaTekstikentta_Click(object sender, EventArgs e)
        {
            //Seuraavassa sanaTekstikentta:n ja merkitysTekstikentta:n
            //tekstisisältö poistetaan.
            sanaTekstikentta.Text = "";
            merkitysTekstikentta.Text = "";
           
            
        }

        private void sanaTekstikentta_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
