﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Tehtava6_2
{
    public partial class Paaikkuna : Form
    {

       
        
        public Paaikkuna()
        {
            InitializeComponent();
        }


        

        private void Paaikkuna_Load(object sender, EventArgs e)
        {

            //Seuraavissa luodaan uusia Talo-olioita lennossa ja lisätään
            //listanäkymään talotListView.
            talotListView.Items.Add(new Talo("Rantatie 2", "186.5", "180000.0"));
            talotListView.Items.Add(new Talo("Aurinkotie 6", "96.5", "100000.0"));
            talotListView.Items.Add(new Talo("Kuutamotie 10", "386.5", "400000.0"));

            //Seuraavissa listanäkymän elementeille määritellään kuvaindekseja. 
            talotListView.Items[0].ImageIndex = 0;
            talotListView.Items[1].ImageIndex = 1;
            talotListView.Items[2].ImageIndex = 2;

            //Seuraavissa listanäkymän Details-näkymää varten määritellään
            //sarakkeita. Sarakkeiden määrittelyä varten tarvitaan sarakkeen nimi,
            //leveys ja sarakkeen tekstin tasoitustapa.
            talotListView.Columns.Add("Osoite", 120, HorizontalAlignment.Center);
            talotListView.Columns.Add("Pinta-ala", 100, HorizontalAlignment.Center);
            talotListView.Columns.Add("Hinta", 100, HorizontalAlignment.Center);
            
        

           //Tässä luodaan kuvalista SmallIcon-näkymää varten.
            ImageList imageListSmall = new ImageList();


            //Tässä määritellään kuvien polku.
            string kuvaPolku = @"C:\Temp\Kirja\Kirja2010_OK\Esimerkit\Esimerkit_luku6\Esimerkki6_1\Resources\";

            //Seuraavissa lisätään kuvalistaan kuvia.
            imageListSmall.Images.Add(Bitmap.FromFile(kuvaPolku + "Pienikoti1.jpg"));
            imageListSmall.Images.Add(Bitmap.FromFile(kuvaPolku + "Pienikoti2.jpg"));
            imageListSmall.Images.Add(Bitmap.FromFile(kuvaPolku + "Pienikoti3.jpg"));


            //Tässä luodaan kuvalista LargeIcon-näkymää varten.
            ImageList imageListLarge = new ImageList();

            //Seuraavissa lisätään kuvalistaan kuvia.
            imageListLarge.Images.Add(Bitmap.FromFile(kuvaPolku + "Isokoti1.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile(kuvaPolku + "Isokoti2.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile(kuvaPolku + "Isokoti3.bmp"));


           //Seuraavissa alustetaan listanäkymän eri näkymien kuvalistat. 
            talotListView.LargeImageList = imageListLarge;
            talotListView.SmallImageList = imageListSmall;
           
            //Tässä määritellään saako listanäkymän sarakkeiden järjestystä muuttaa. 
            talotListView.AllowColumnReorder = true;

           

           
        }



     
        private void talotListView_ItemChecked(object sender, ItemCheckedEventArgs e)
        {
            //Seuraavissa varmistetaan, että valittujen talojen yhteissumma on nolla
            //ja että se myös näytetään sille varatulla lipukkeella.
           // double yhteisSumma = 0.0;
            valitutTalotHintaLipuke.Text = "" + 0.0;

          
           
        }



        //Tässä määritellään globaali muuttuja, joka määrää lajittelutavan.
        bool nousevaLajittelu = true;

        private void talotListView_ColumnClick(object sender, ColumnClickEventArgs e)
        {

            //Seuraavissa muuttujan nousevaLajittelu arvo muutetaan
            //seuraavaa kierrosta varten. Tällä lailla saadaan sarakkeen
            //sisältö lajiteltua päinvastaiseen suuntaan kuin edellisellä kerralla. 
            if (nousevaLajittelu)
                nousevaLajittelu = false;
            else
                nousevaLajittelu = true;

            //Tässä luodaan ListViewItem-olioita varten taulukko,
            //jonka koko määräytyy listanäkymän elemenntien määrän mukaan.
            ListViewItem[] listViewItemTaulukko = new ListViewItem[talotListView.Items.Count];

            //Tässä listanäkymän elementit kopioidaan listViewItemTaulukko:on.
            talotListView.Items.CopyTo(listViewItemTaulukko, 0);

            //Tässä selvitetään napsautetun sarakkeen nimi. Huomaa,
            //kuinka napsautettu sarake saadaan selville listanäkymän
            //Columns-kokoelman ja tapahtumankäsittelijän
            //ColumnClickEventArgs-olion (e) avulla.  
            string valittuSarake = (talotListView.Columns[e.Column]).Text;
         
             //Tässä Talo-olioiden lajittelukriteeriksi laitetaan
            //napsautetun sarakkeen nimi.
            Talo.lajitteluKriteeri = valittuSarake;

            //Seuraavissa listViewItemTaulukko:n sislältö lajitellaan
            //joko nousevaan tai laskevaan järjestykseen.
            if(nousevaLajittelu)
              Array.Sort(listViewItemTaulukko);
            else         
              Array.Reverse(listViewItemTaulukko);

            //Tässä poisteaan listanäkymän kaikki elementit. 
            talotListView.Items.Clear();

            //Tässä listViewItemTaulukko:n sisältö kopioidaan
            //listanäkymään.
            foreach (ListViewItem elementti in listViewItemTaulukko)
                talotListView.Items.Add(elementti);
        
        }

        private void nakymaPudotusValikko_SelectedIndexChanged(object sender, EventArgs e)
        {

            //Tässä listanäkymän valintaruudut poistetaan. Tämä tehdään sen takia
            //että listanäkymässä ei saa olla valintaruutuja jos sen näkymäksi (View)
            //laitetaan Tile. Tässä myöhemmin valintaruudut otetaan käyttöön jos on
            //varmistunut, että näkymä ei ole Tile.
            talotListView.CheckBoxes = false;

           
           
           
        }

        int i = 0;
        object[] nakymat = new object[] { View.Details, View.LargeIcon, View.List, View.SmallIcon, View.Tile };
        private void talotListView_DoubleClick(object sender, EventArgs e)
        {

           
            if(i>(nakymat.Length-1))
                i=0;
            
            talotListView.View=(View) nakymat[i];

            i++;
        }

        private void talotListView_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void detailsLabel_Click(object sender, EventArgs e)
        {


            talotListView.View = View.Details;
        }

        private void largeIconLable_Click(object sender, EventArgs e)
        {
            talotListView.View = View.LargeIcon;
        }

        private void listLabel_Click(object sender, EventArgs e)
        {
            talotListView.View = View.List;
        }

        private void smallIconLabel_Click(object sender, EventArgs e)
        {
            talotListView.View = View.SmallIcon;
        }

        private void tileLabel_Click(object sender, EventArgs e)
        {
            talotListView.View = View.Tile;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

     


    }
}
