﻿using System;
using System.Windows.Forms;

namespace Tehtava6_5
{

       //Seuraavassa määritellään Talo-luokka, joka johdetaan ListViewItem-
       //luokasta. Tämä on erittäin tärkeä koska Talo-luokan olioita halutaan
      //myöhemmin lisätä listanäkymään (ListView) ja tämä on mahdollista vain jos
       //oliot ovat tyyppiä ListVewItem tai sen johdannaisia. Talo-luokka myös
    //toteuttaa IComparable-liittymän. Tämä on tärkeä jos halutaan pystyä
    //lajittelemaan Talo-luokan olioita. 
        class Talo : ListViewItem, IComparable
        {
            
            private string osoite;
            private string pintaAla;
            private string hinta;

            //Tässä määritellään muuttuja lajitteluKriteeri, jonka
            //mukaan Talo-olioita voidaan lajitella. 
            public static string lajitteluKriteeri = "Osoite";
         
            //Seuraavassa määritellään luokan muodostin.
            public Talo(string osoite, string pintaAla, string hinta)
            {

                this.osoite = osoite;
                this.pintaAla = pintaAla;
                this.hinta = hinta;


                //Tässä listanäkymän olion (ListViewItem) nimeksi laitetaan
                //talon osoite. 
                 base.Text = osoite;

                 //Seuraavissa listanäkymän oliolle määritellään
                //alielementtejä eli lisäominaisuuksia.
                 base.SubItems.Add(pintaAla);
                 base.SubItems.Add(hinta);
            }


            //Seuraavassa määritellään lukuominaisuus Osoite.
            public string Osoite
            {
                get
                {

                    return osoite;

                }

            }


            //Seuraavassa määritellään lukuominaisuus PintaAla.
            public string PintaAla
            {

                get
                {

                    return pintaAla;

                }

            }

            //Seuraavassa määritellään lukuominaisuus Hinta.
            public string Hinta
            {
                get
                {

                    return hinta;
                }

            }


            //Seuraavassa määritellään CompareTo()-metodi, joka
            //kuuluu IComparable-liittymään.
            public int CompareTo(Object vertailuOlio)
            {

                int vertailuTulos = 0;

                //Seuraavissa tarkistetaan muuttujan lajitteluKriteeri arvo
                //ja sen perusteella kutsutaan sopiva lajittelumetodi.
                if (lajitteluKriteeri.Equals("Osoite"))
                    vertailuTulos = VertaileOsoite(vertailuOlio);

                else if (lajitteluKriteeri.Equals("PintaAla"))
                    vertailuTulos = VertailePintaAla(vertailuOlio);
                
                else
                    vertailuTulos = VertaileHinta(vertailuOlio);


                return vertailuTulos;


            }


            //Seuraavassa määritellään VertaileOsoite-metodi, joka
            //vertailee olioiden osoitteita.
            private int VertaileOsoite(Object vertailuOlio)
            {
                Talo talo = (Talo) vertailuOlio;

                if (this.osoite.CompareTo(talo.osoite) < 1)
                    return -1;
                if (this.osoite.CompareTo(talo.osoite) > 1)
                    return 1;
                else
                    return 0;
            }



            //Seuraavassa määritellään VertaileOsoite-metodi, joka
            //vertailee olioiden hintoja.
            private int VertaileHinta(Object vertailuOlio)
            {
                Talo talo = (Talo) vertailuOlio;

                if (this.hinta.CompareTo(talo.hinta) < 1)
                    return -1;
                if (this.hinta.CompareTo(talo.hinta) > 1)
                    return 1;
                else
                    return 0;
            }

            //Seuraavassa määritellään VertaileOsoite-metodi, joka
            //vertailee olioiden pinta-aloja.
            private int VertailePintaAla(Object vertailuOlio)
            {
                Talo talo = (Talo)vertailuOlio;

                if (this.hinta.CompareTo(talo.pintaAla) < 1)
                    return -1;
                if (this.hinta.CompareTo(talo.pintaAla) > 1)
                    return 1;
                else
                    return 0;
            }

            //Tässä määritellään metodi, joka palauttaa
            //Talo-olioiden ominaisuuksien nimet taulukkona.
            public static string[] ominaisuudet()
            {
                return new string[] {"Osoite", "Pinta-ala", "Hinta" };

            }

            //Seuraavassa määritellään ToString()-metodi, joka
            //palauttaa merkkijonvastineen oliosta.
            public override string ToString()
            {
                return osoite + "\t" + pintaAla + "\t" + hinta;

            }

        }

    } 



