﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Esimerkki9_1
{
    public partial class Paaikkuna : Form
    {
        //Tässä esitellään tekstinFontti, jota käytetään esitettävän
        //tekstin fontin määrittelemiseksi. 
        Font tekstinFontti;

        //Tässä määritellään fonttiPerhe-muuttuja, jota käytetään
        //fontin määrittelemiseksi. 
        FontFamily fonttiPerhe = new FontFamily("Times New Roman");

        //Tässä määritellään fontinKoko-muuttuja, jota käytetään
        //fontin määrittelemiseksi.
        int fontinKoko = 10;

        //Tässä määritellään fontinTyyli-muuttuja, jota käytetään
        //fontin määrittelemiseksi.
        FontStyle fontinTyyli = FontStyle.Regular;

        //Tässä esitellään globaalimuuttuja tiedosto, joka tulee
        //sisältämään käsiteltävän tiedoston täydellisen osoitteen.
        string tiedosto = "";


        public Paaikkuna()
        {
            InitializeComponent();
        }


       

        private void kopioiToolStripMenuItem_Click(object sender, EventArgs e)
        {
           // if (tiedostoRichTextBox.SelectedText.Length != 0)
                tiedostoRichTextBox.Copy();
        }
        

        private void avaaToolStripTextBox_KeyUp(object sender, KeyEventArgs e)
        {

            //Tässä muuttuja tiedosto alustetaan avaaToolStripTextBox-tekstikentän
            //tekstillä.
            tiedosto = avaaToolStripTextBox.Text;

            //Tässä KeyEventArgs-olion eli e:n kautta tarkistetaan onko Enter-näppäintä 
            //painettu ja että tiedosto-muuttujan arvo ei ole tyhjä tai null.  
            if (e.KeyCode.Equals(Keys.Enter) && !string.IsNullOrEmpty(tiedosto))
            {

                //Seuraavassa varmistetaan, että virheen sattuessa sitä
                //käsitellään hallitusti.
                try
                {
                    //Tässä luodaan lukuvirta, joka alustetaan tiedosto-muuttujan
                    //osoittamaan tiedoston sisällöllä.
                    StreamReader lukuVirta = File.OpenText(tiedosto);

                   
                   //Tässä tiedostom koko sisältö luetaan muistiin. Huomaa, että
                   //koska tiedostonSisalto-muuttuja on tyyppiä string, teksti saa
                   //UTF-16-koodauksen ja näin pystytään lukemaan myös tiedoston formaatti.  
                    String tiedostonSisalto = lukuVirta.ReadToEnd();

                    //Tässä tiedostoRichTextBox-tekstialueen Rtf-ominaisuudeksi
                    //laitetaan luetun tiedoston koko sisältö. Huomaa, että jos
                    //tekstialueen Text-ominaisuuden arvoksi olisi laitettu lueteun
                    //tiedoston sisältö, tiedoston formaatin näyttäminen olisi 
                    //epäonnistunut.
                    tiedostoRichTextBox.Rtf = tiedostonSisalto;
                  
                    //Tässä lukuvirta suljetaan.
                    lukuVirta.Close();

                    //Tässä avatun tiedoston nimi lisätään luetteloToolStripComboBox-
                    //pudotusvalikon ensimmäiseksi elementiksi jos sitä ei löydy jo
                    //pudotusvalikosta.
                    if (luetteloToolStripComboBox.Items.IndexOf(tiedosto) == -1)
                        luetteloToolStripComboBox.Items.Insert(0, tiedosto);
                   
                        //Seuraavassa jos elementti löytyy pudotusvalikosta, ensin se
                    //poistetaan ja sitten se laitetaan pudotusvalikon alkuun.
                    else
                    {
                        luetteloToolStripComboBox.Items.Remove(tiedosto);
                        luetteloToolStripComboBox.Items.Insert(0, tiedosto);

                    }

                    //Tässä valitaan pudotusvalikon ensimmäinen elementti, 
                    //jok on juuri avatun tiedoston osoite.  
                    luetteloToolStripComboBox.SelectedIndex = 0;

                    //Tässä Tiedosto-alavalikko sljetaan.
                    tiedostoToolStripMenuItem.HideDropDown();

                }
                catch (Exception ex)
                {
                    //Tässä näytetään virheilmoitus jos tapahtuu virhe.
                    MessageBox.Show(tiedosto + " on virheellinen!" + ex.ToString(), "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }

        


        }

        private void uusiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tiedostoRichTextBox.Text = "";
        }

        private void tallennaToolStripTextBox_Click(object sender, EventArgs e)
        {



        }

        private void tallennaToolStripTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            //Tässä tiedosto-muuttuja alustetaan tallennaToolStripTextBox-
            //tekstikentän sisällöllä.
            tiedosto = tallennaToolStripTextBox.Text;

            //Tässä KeyEventArgs-olion eli e:n kautta tarkistetaan onko Enter-näppäintä 
            //painettu ja että tiedosto-muuttujan arvo ei ole tyhjä tai null.  
            if (e.KeyCode.Equals(Keys.Enter) && !string.IsNullOrEmpty(tiedosto))
            {

                //Seuraavassa varmistetaan, että virheen sattuessa sitä
                //käsitellään hallitusti.
                try
                {
                    //Tässä luodaan kirjoitusvirta tiedostoon, jonka täydellinen
                    //osoite on tiedosto-mmuuttjan arvo.
                    StreamWriter kirjoitusVirta = File.CreateText(tiedosto);

                    //Tässä tiedostoRichTextBox-tekstikentän sisältö 
                    //muotoiluineen kirjoitetaan määrättyyn tiedostoon.
                    //Huomaa, että tiedostoRichTextBox.Text argumentti 
                    //olisi tallentanut vain tekstialueen tekstin ilman 
                    //muotoilua (formaattia).
                    kirjoitusVirta.WriteLine(tiedostoRichTextBox.Rtf);
                 
                    //Tässä olisi toinen tapa tallentaa RTF-tekstialueen
                   //sisältö.
                  //tiedostoRichTextBox.SaveFile(tiedosto);

                    //Tässä kirjoitusvirt suljetaan.
                    kirjoitusVirta.Close();

                    //Tässä Tiedosto-alavalikko suljetaan.
                    tiedostoToolStripMenuItem.HideDropDown();
             
                }
                catch (Exception ex)
                {

                    //Tässä näytetään virheilmoitus jos tapahtuu virhe.
                    MessageBox.Show(tiedosto + " on virheellinen!" + ex.ToString(), "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }


        private void luetteloToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void lopetaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä ohjelma lopetetaan.
            Application.Exit();
        }

        private void liimaaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä leikepöydälle kopioitu teksti liimataan tekstialueen 
            //kohtaan, jota on napsautettu.
            tiedostoRichTextBox.Paste();
        }

        private void leikkaaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä tekstialueen valittu tekstipätkä kopioidaan leikepöydälle
            //ja poistetaan tekstialueesta. 
            tiedostoRichTextBox.Cut();
        }


      
        private void timesNewRomanToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fonttiPerhe=new FontFamily(timesNewRomanToolStripMenuItem.Text);
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;

        }

        private void courierNewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fonttiPerhe = new FontFamily(courierNewToolStripMenuItem.Text);
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void arialToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fonttiPerhe = new FontFamily(arialToolStripMenuItem.Text);
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void suurennaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontinKoko++;
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void pienennäToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontinKoko--;
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void normaaliToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä fontin tyyliksi laitetaan Regular.
            fontinTyyli = FontStyle.Regular;

            //Tässä tekstinFontti alustetaa uudella fontin tyylillä.
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
 
            //Tässä tekstialueen valitun tekstipätkän fontiksi laitetaan
            //juuri määritelty fontti. 
            tiedostoRichTextBox.SelectionFont = tekstinFontti;

            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void lihavoiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontinTyyli = FontStyle.Bold;
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;


            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            //tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void kursivoiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fontinTyyli = FontStyle.Italic;
            tekstinFontti = new Font(fonttiPerhe, fontinKoko, fontinTyyli);
            tiedostoRichTextBox.SelectionFont = tekstinFontti;


            //Seuraavalla rivillä koko tekstialueen fontiksi olisi 
            //laitettu tekstinFontti.
            // tiedostoRichTextBox.Font = tekstinFontti;
        }

        private void punainenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä valitun tekstipätkän väriksi laitetaan punainen.
            tiedostoRichTextBox.SelectionColor = Color.Red;

            //Seuraava rivi muuttaisi koko tekstialueen tekstivärin punaiseksi.
            //tiedostoRichTextBox.ForeColor = Color.Red;
        }

    

        private void mustaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä valitun tekstipätkän väriksi laitetaan musta.
            tiedostoRichTextBox.SelectionColor = Color.Black;

            //Seuraava rivi muuttaisi koko tekstialueen tekstivärin mustaksi.
            //tiedostoRichTextBox.ForeColor =Color.Black;
        }

        private void sininenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä valitun tekstipätkän väriksi laitetaan sininen.
            tiedostoRichTextBox.SelectionColor = Color.Blue;

            //Seuraava rivi muuttaisi koko tekstialueen tekstivärin mustaksi.
            //tiedostoRichTextBox.ForeColor =Color.Blue;
        }

        private void avaaToolStripTextBox_Click(object sender, EventArgs e)
        {

        }

       

      
    }
}