﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki9_3
{
    public partial class Paaikkuna : Form
    {

        //Seuraavassa määritellään joukko globaalimuuttujia, joilla
        //piirtäminen hoidetaan.
        string piirrettäväMuoto;
       
        //Tässä esitellään pääikkunanTaustaväri-muuttuja, jolla
        //tallennetaan pääikkunan alkuperäinen taustaväri 
        Color pääikkunanTaustaväri;

        //Tässä esitellään pääikkunanKoko-muuttuja, jolla
        //tallennetaan pääikkunan alkuperäinen koko. 
        Size pääikkunanKoko;

        //Tässä esitellään pääikkunanSijainti-muuttuja, jolla
        //tallennetaan pääikkunan alkuperäinen sijainti. 
        Point pääikkunanSijainti;

        //Tässä esitellään grafiikka-olio, joka on instanssi
        //Graphics-luokasta, joka puolestaan tarjoaa erilaiset metodit
        //grafiikan toteuttamiseen.
        Graphics grafiikka;


        //Tässä määritellään kynä-olio, joka on Pen-luokan instanssi
        //ja jolla voidaan määrätä piirrystysväri.
        Pen kynä;

        //Tässä määritellään pensselit-olio, joka on Brush-luokan instanssi
        //ja jolla voidaan piirtää täytettyjä kuvia.
        Brush pensseli;

        //Tässä määritellään satunnaislukugeneraattori.
        Random satunnaisLuku;

        //Tässä määritellään joukko värejä taustaväriksi.
        Color[] taustaVärit = new Color[] { Color.Yellow, Color.Red, Color.Blue };

        //Tässä määritellään leveys- ja korkeus-muuttujat suorakolmion
        //ja piirakkan piirtämiseksi.
        int leveys, korkeus;

        //Tässä määritellään muutos-vakio, jolla ikkunan kokoa 
        //muutetaan tilanteen mukaan. 
        const int muutos = 10;

        public Paaikkuna()
        {
            InitializeComponent();

            //Tässä tallennetaan pääikkunan taustaväri myöhempää käyttöä varten.
             pääikkunanTaustaväri = this.BackColor;

             //Tässä tallennetaan pääikkunan käyttöalueen koko myöhempää käyttöä varten.
             pääikkunanKoko = this.ClientSize;

             //Tässä tallennetaan pääikkunan sijainti myöhempää käyttöä varten.
             pääikkunanSijainti = this.Location;

             //Tässä satunnaisLuku-muuttuja alusteaan ja sille varataan muistitila. 
             satunnaisLuku = new Random();
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            //Tässä taustaVäritToolStripComboBox-pudotusvalikon
            //valituksi alkioksi laitetaan ensimmäinen.
            taustaVäritToolStripComboBox.SelectedIndex=0;
        }

     

      


        private void suoraViivaToolStripMenuItem_Click(object sender, EventArgs e)
        {

            piirrettäväMuoto = "suoraviiva";


            //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
            //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
            //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
            //grafiikka myös piirretään uudelleen.
             Refresh();
          
        }

    

       

        private void Suorakulmio_Click(object sender, EventArgs e)
        
        {
            piirrettäväMuoto = "suorakulmio";


            //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
            //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
            //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
            //grafiikka myös piirretään uudelleen.
            Refresh();
        }


      

        private void Paaikkuna_Paint(object sender, PaintEventArgs e)
        {

            //Tässä grafiikkaresurssit varataan pääikkunan päälle
            //piirtämistä varten.
            grafiikka = this.CreateGraphics();

            //Seuraavissa tarkistetaan onko annetut leveys- ja korkeus-
            //arvot suurempis kuin pääikkunan leveys ja korkeus. Jos on,
            //pääikkunan käyttöalueen koko muutetaan vastaavasti.
            if (pääikkunanKoko.Width < leveys)
                pääikkunanKoko.Width = leveys + 20;

            if (pääikkunanKoko.Height < korkeus)
                pääikkunanKoko.Height = korkeus + 20;

            //Tässä päivitetään pääikkunan käyttöalueen kokoa.
            this.ClientSize = pääikkunanKoko;
       
            //Seuraavassa kynä- ja pensseli-oliot alustetaan satunnaisilla väreillä jos 
            //taustaVäritToolStripComboBox-pudotusvalikosta on valittu Satunnainen. Muussa
            //tapauksessa kynä- ja pensseli-oliot alustetaan pudotusvalikosta valitulla värillä.
            if (taustaVäritToolStripComboBox.SelectedItem.ToString().Equals("Satunnainen"))
            {
                kynä = new Pen(Color.FromArgb(satunnaisLuku.Next(256), satunnaisLuku.Next(256), satunnaisLuku.Next(256)), satunnaisLuku.Next(20) + 1);
                pensseli = new SolidBrush(Color.FromArgb(satunnaisLuku.Next(256), satunnaisLuku.Next(256), satunnaisLuku.Next(256)));
            }
            else
            {
                kynä = new Pen(taustaVärit[taustaVäritToolStripComboBox.SelectedIndex], satunnaisLuku.Next(20) + 1);
                pensseli = new SolidBrush(taustaVärit[taustaVäritToolStripComboBox.SelectedIndex]);
            }


            //Seuraavassa selvitetään mikä muoto on valittu piirrettäväksi ja
            //sen mukaan muoto piirretään.
            switch(piirrettäväMuoto) {

                case "suorakulmio":

                    
                    //Tässä määritellään piirrettävän suorakulmion vasen yläkulma.
                Point vasenYläKulma = new Point(this.ClientRectangle.Left + 10, this.ClientRectangle.Top + 10);

                //Tässä määritellään piirrettävän suorakulmion koko.
                Size koko = new Size(leveys, korkeus);

                // //Tässä määritellään piirrettävän suorakulmion alue.
                Rectangle suoraKulmio = new Rectangle(vasenYläKulma, koko);


                    //Tässä piirretään täytetty suorakulmio.
                grafiikka.FillRectangle(pensseli, suoraKulmio);

                //Tässä piirretään suorakulmiolle reunat.
                grafiikka.DrawRectangle(new Pen(Color.Orchid, 2.0f), suoraKulmio);


                    //Seuraavassa sopiva valikko merkitään valituksi ja mahdollinen merkintä
                    //poistetaan muista alkioista.
                suorakulmioToolStripMenuItem.Checked = true;
                piirakkaToolStripMenuItem.Checked = false;
                suoraViivaToolStripMenuItem.Checked = false;

                    break;

                case "suoraviiva":

                    //Tässä määritellään piirrettävän suoraviivan alku- ja loppupisteen koordinaatit.
            Point alkuPiste = new Point(this.ClientRectangle.Left + 10, this.ClientRectangle.Top + 10);
            Point loppuPiste = new Point(satunnaisLuku.Next(this.ClientRectangle.Right), satunnaisLuku.Next(this.ClientRectangle.Bottom));
           

                    //Tässä määritelty viiva piirretään.
            grafiikka.DrawLine(kynä, alkuPiste, loppuPiste);

            //Seuraavassa sopiva valikko merkitään valituksi ja mahdollinen merkintä
            //poistetaan muista alkioista.
            suorakulmioToolStripMenuItem.Checked = false;
            piirakkaToolStripMenuItem.Checked = false;
            suoraViivaToolStripMenuItem.Checked = true;


            break;

                case "piirakka":

            //Tässä määritellään piirrettävän piirakan vasen yläkulma.
                 vasenYläKulma = new Point(this.ClientRectangle.Left + 10, this.ClientRectangle.Top+10);


                 //Tässä määritellään piirrettävän piirakan koko.
                 koko = new Size(leveys, korkeus);

                 //Tässä määritellään piirrettävän piirakan alue.
                 suoraKulmio = new Rectangle(vasenYläKulma, koko);

                    //Tässä piirretään määritelty piirakka.
                 grafiikka.FillPie(pensseli, suoraKulmio, 0, 245);
              
               
                    //Tässä piirretylle piirakalle piirretään reunat.
                 grafiikka.DrawPie(new Pen(Color.PaleVioletRed, 2.0f), suoraKulmio, 0, 245);


                //Seuraavassa sopiva valikko merkitään valituksi ja mahdollinen merkintä
                //poistetaan muista alkioista.
                suorakulmioToolStripMenuItem.Checked = false;
                piirakkaToolStripMenuItem.Checked = true;
                suoraViivaToolStripMenuItem.Checked = false;



            break;

            }


            //Tässä vapautetaan grafiikkaresurssit.
            grafiikka.Dispose();

        }

        private void suorakulmioKokoTekstikenttä_Click(object sender, EventArgs e)
        {
            //Tässä tekstikentän tekstisisältö poistetaan.
            suorakulmioKokoToolStripTextBox.Text = "";
        }

        

        private void suorakulmioKokoToolStripTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            //Tässä tarkistetaan onko painettu näppäin Enter vai ei. Huomaa,
            //kuinka Keys-luettelosta saadaan näppäimen koodi selville.
            if (e.KeyCode.Equals(Keys.Enter))
            {
                //Tässä määritellään erotinmerkit, joilla tekstikentän arvot
                //erotetaan toisistaan.
                char[] erotin = new char[] { ' ' };

                //Tässä suorakulmioKokoToolStripTextBox-tekstikentän tekstisisältö
                //pilkotaan osiin erotinmerkkien mukaan.
                string[] koko = suorakulmioKokoToolStripTextBox.Text.Split(erotin);

                //Seuraavassa käytetään try...catch-lohkoa, jonka avulla voidaan
                //tarkistaa onko tekstikentästä luettu teksti muunnettavissa luvuiksi.
                
                try
                {
                    //Seuraavassa luetut tekstiarvot muunnetaan luvuiksi.
                    leveys = int.Parse(koko[0]);
                    korkeus = int.Parse(koko[1]);

                    //Tässä Suorakulma-alavalikko merkitään valituksi. 
                    suorakulmioToolStripMenuItem.Checked = true;
                }
                catch (Exception)
                {
                    //Tässä näytetään virheilmoitusikkuna.
                    MessageBox.Show("Virheellinen koko!", "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                //Tässä ilmoitetaan piirrtteävä muoto.
                piirrettäväMuoto = "suorakulmio";

                //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
                //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
                //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
                //grafiikka myös piirretään uudelleen.
                Refresh();
            }

        }

        private void taustaVaritPudotusValikko_Click(object sender, EventArgs e)
        {

        }


        
        private void taustaVaritPudotusValikko_SelectedIndexChanged(object sender, EventArgs e)
        {

            //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
            //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
            //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
            //grafiikka myös piirretään uudelleen.
             Refresh();
        }

        private void suurennaIkkunaaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä pääikkunanKokoa päivitetään kasvattamalla sekä sen leveyttä että korkeutta
            //muutos-mmuuttujan määräämällä yksiköllä. 
            pääikkunanKoko = new Size(pääikkunanKoko.Width + muutos, pääikkunanKoko.Height + muutos);

            //Tässä päivitetään pääikkunan käyttöalueen koko. 
            this.ClientSize = pääikkunanKoko;

            //Seuraavassa myös päivitetään piirrettävän muodon kokoa.
            leveys += muutos;
            korkeus += muutos;

            //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
            //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
            //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
            //grafiikka myös piirretään uudelleen.
            Refresh();
        }

        private void pienennäIkkunaaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä pääikkunanKokoa päivitetään pienentämällä sekä sen leveyttä että korkeutta
            //muutos-mmuuttujan määräämällä yksiköllä. 
            pääikkunanKoko = new Size(pääikkunanKoko.Width - muutos, pääikkunanKoko.Height - muutos);

            //Tässä päivitetään pääikkunan käyttöalueen koko. 
            this.ClientSize = pääikkunanKoko;

            //Seuraavassa myös päivitetään piirrettävän muodon kokoa.
            leveys -= muutos;
            korkeus -= muutos;

            //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
            //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
            //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
            //grafiikka myös piirretään uudelleen.
            Refresh();
        }

        private void ikkunaEteenpäinToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä pääikkunanSijaintia päivitetään kasvattamalla sen X:n ja Y:n
            //arvoja muutos-mmuuttujan määräämällä yksiköllä. 
            pääikkunanSijainti = new Point(pääikkunanSijainti.X + muutos, pääikkunanSijainti.Y + muutos);

            //Tässä pääikkunan sijainti päivitetään.  
            this.Location = pääikkunanSijainti;
        }

        private void ikkunaTaaksepäinToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Tässä pääikkunanSijaintia päivitetään kasvattamalla sen X:n ja Y:n
            //arvoja muutos-mmuuttujan määräämällä yksiköllä. 
            pääikkunanSijainti = new Point(pääikkunanSijainti.X - muutos, pääikkunanSijainti.Y - muutos);

            //Tässä pääikkunan sijainti päivitetään.  
            this.Location = pääikkunanSijainti;
        }

       
        private void piirakkaToolStripMenuItem_KeyUp(object sender, KeyEventArgs e)
        {

            
        }

        private void ikkunanKokoToolStripTextBox_Click(object sender, EventArgs e)
        {
            //Tässä ikkunanKokoToolStripTextBox-tekstikentän tekstisisältö
            //poistetaan.
            ikkunanKokoToolStripTextBox.Text = "";
        }

        private void ikkunanKokoToolStripTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            //Tässä tarkistetaan oko painettu näppäin Enter.
            if (e.KeyCode.Equals(Keys.Enter))
            {
                //Tässä määritellään erotinmerkit, joilla tekstikentän arvot
                //erotetaan toisistaan.
                char[] erotin = new char[] { ' ' };

                //Tässä piirakkaKokoToolStripTextBox-tekstikentän tekstisisältö
                //pilkotaan osiin erotinmerkkien mukaan.
                string[] koko = ikkunanKokoToolStripTextBox.Text.Split(erotin);

                //Seuraavassa käytetään try...catch-lohkoa, jonka avulla voidaan
                //tarkistaa onko tekstikentästä luettu teksti muunnettavissa luvuiksi.
                try
                {
                    //Tässä pääikkunanKoko-muuttujan arvo päivitetään.
                    pääikkunanKoko = new Size(int.Parse(koko[0]), int.Parse(koko[1]));
                   
                    //Tässä pääikkunan käyttöalueen kokoa päivitetään. 
                    this.ClientSize = pääikkunanKoko;
                }
                catch (Exception)
                {
                    //Tässä näytetään virheilmoitusikkuna.
                    MessageBox.Show("Virheellinen koko!", "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);

                }
            }
        }

        private void piirakkaKokoToolStripTextBox_Click(object sender, EventArgs e)
        {
            piirakkaKokoToolStripTextBox.Text = "";
        }

        private void piirakkaKokoToolStripTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            //Tässä tarkistetaan onko painettu näppäin Enter vai ei. Huomaa,
            //kuinka Keys-luettelosta saadaan näppäimen koodi selville.
            if (e.KeyCode.Equals(Keys.Enter))
            {

                //Tässä määritellään erotinmerkit, joilla tekstikentän arvot
                //erotetaan toisistaan.
                char[] erotin = new char[] { ' ' };

                //Tässä piirakkaKokoToolStripTextBox-tekstikentän tekstisisältö
                //pilkotaan osiin erotinmerkkien mukaan.
                string[] koko = piirakkaKokoToolStripTextBox.Text.Split(erotin);

                //Seuraavassa käytetään try...catch-lohkoa, jonka avulla voidaan
                //tarkistaa onko tekstikentästä luettu teksti muunnettavissa luvuiksi.
                try
                {
                    //Seuraavassa luetut tekstiarvot muunnetaan luvuiksi.
                    leveys = int.Parse(koko[0]);
                    korkeus = int.Parse(koko[1]);

                    //Tässä Ympyrä-alavalikko merkitään valituksi. 
                    piirakkaToolStripMenuItem.Checked = true;

                }
                catch (Exception)
                {
                    //Tässä näytetään virheilmoitusikkuna.
                    MessageBox.Show("Virheellinen koko!", "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);

                }


                //Tässä ilmoitetaan piirrtteävä muoto.
                piirrettäväMuoto = "piirakka";

                //Tässä pääikkuna pakotetaan piirtämään itsensä, minkä seurauksena pääikkuna
                //ja kaikki sen sisältämät komponentit piirretään uudelleen. Tämän seurauksena
                //myös pääikkunan Paint()-tapahtumankäsittelijä kutsutaan ja näin siihen kuuluvat
                //grafiikka myös piirretään uudelleen.
                Refresh();

            }
        }

      
    
       
 
    }
}
