﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Esimerkki9_4
{
    public partial class GrafiikkaIkkuna : Form
    {

        //Seuraavassa määritellään joukko globaalimuuttujia,
        //joita käytetään grafiikan piirtämiseen.
        private Bitmap piirrustusAlue;
        private Color piirrustusVäri = Color.Black;
        Graphics grafiikka;




        public GrafiikkaIkkuna()
        {
            InitializeComponent();
        }


        private void alustaVapaaPiirrustus(MouseEventArgs e, Bitmap piirrustusAlue)
        {
            //Create a Graphics object that references the bitmap and clears it
            grafiikka = Graphics.FromImage(piirrustusAlue);

            //Create a rectangle the same size as the bitmap
           // Rectangle rect = new Rectangle(0, 0, 2, 2);

            grafiikka.FillEllipse(new SolidBrush(piirrustusVäri), e.X, e.Y, 4, 4);

            grafiikka.Dispose();

        }



        private void PyyhiPiirrusus(Bitmap piirrustusAlue)
        {

            //   piirrustusPaneeli.BackColor = Color.Green;
            //piirrustusAlue = new Bitmap(piirrustusPaneeli.Width, piirrustusPaneeli.Height,
            //System.Drawing.Imaging.PixelFormat.Format16bppRgb565);


            //Create a Graphics object that references the bitmap and clears it
            grafiikka = Graphics.FromImage(piirrustusAlue);

            //Here we set the background color of the bitmap
            grafiikka.Clear(SystemColors.GradientActiveCaption);

            grafiikka = piirrustusPaneeli.CreateGraphics();

            grafiikka.DrawImage(piirrustusAlue, piirrustusPaneeli.Left, piirrustusPaneeli.Top);


            grafiikka.Dispose();
        }


      
        
        private void Grafiikka_Load(object sender, EventArgs e)
        {

            piirrustusAlue = new Bitmap(piirrustusPaneeli.Width, piirrustusPaneeli.Height,
           System.Drawing.Imaging.PixelFormat.Format16bppRgb565);

            PyyhiPiirrusus(piirrustusAlue);
          


        }

        private void this_MouseMove(object sender, MouseEventArgs e)
        {
            


        }

        private void GrafiikkaIkkuna_MouseMove(object sender, MouseEventArgs e)
        {
           

        }

        private void piirrustusPaneeli_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left)
                return;

            alustaVapaaPiirrustus(e, piirrustusAlue);
            Graphics g = piirrustusPaneeli.CreateGraphics();

            g.DrawImage(piirrustusAlue, piirrustusPaneeli.Left, piirrustusPaneeli.Top);
        }

        private void pyyhiPainike_Click(object sender, EventArgs e)
        {

            //Rectangle paneeliAlue = new Rectangle(piirrustusPaneeli.Left, piirrustusPaneeli.Top, piirrustusPaneeli.Width, piirrustusPaneeli.Height);
            //Graphics grafiikka = piirrustusPaneeli.CreateGraphics();
            //grafiikka.FillRectangle(new SolidBrush(SystemColors.GradientActiveCaption), paneeliAlue);
          
            
            //alustaVapaaPiirrustus((MouseEventArgs)e);

            PyyhiPiirrusus(piirrustusAlue);

        }

        private void piirrustusPaneeli_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = piirrustusPaneeli.CreateGraphics();

            g.DrawImage(piirrustusAlue, piirrustusPaneeli.Left, piirrustusPaneeli.Top);
        }

        private void avaaTekstikenttä_KeyPress(object sender, KeyPressEventArgs e)
        {

           

        }

        private void tallennaTekstikenttä_KeyPress(object sender, KeyPressEventArgs e)
        {
            
            
       
         
        }

        private void tallennaTekstikenttä_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.Equals( Keys.Enter))
            {
                

                try
                {
                    if (piirrustusAlue != null && !string.IsNullOrEmpty(tallennaTekstikenttä.Text))
                    {
                        if (File.Exists(tallennaTekstikenttä.Text))
                            File.Delete(tallennaTekstikenttä.Text);

                        piirrustusAlue.Save(tallennaTekstikenttä.Text);

                        if (File.Exists(tallennaTekstikenttä.Text))
                            MessageBox.Show("Grafiikka on tallennettu tiedostoon: " + tallennaTekstikenttä.Text, "Ilmoitus");

                    }


                }
                catch (Exception)
                {

                    MessageBox.Show("Hakemistopolkua ei löydy", "Virhe");
                }


            }
        }

        private void avaaTekstikenttä_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.Equals(Keys.Enter))
            {


                try
                {
                    if (piirrustusAlue != null && !string.IsNullOrEmpty(tallennaTekstikenttä.Text))
                    {

                        piirrustusAlue = new Bitmap(Bitmap.FromFile(tallennaTekstikenttä.Text));
                         grafiikka = piirrustusPaneeli.CreateGraphics();

                         grafiikka.DrawImage(piirrustusAlue, piirrustusPaneeli.Left, piirrustusPaneeli.Top);
                    }


                }
                catch (Exception)
                {

                    MessageBox.Show("Hakemistopolkua ei löydy", "Virhe");
                }


            }
        }

       

       
       
    }
}
